org.apache.lucene.analysis.ngram

## Class NGramTokenizer

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream
    - - org.apache.lucene.analysis.Tokenizer
      - - org.apache.lucene.analysis.ngram.NGramTokenizer

All Implemented Interfaces:
  Closeable, AutoCloseable

    public final class NGramTokenizer
    extends Tokenizer

Tokenizes the input into n-grams of the given size(s).

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

`AttributeSource.AttributeFactory, AttributeSource.State`

### Field Summary

Fields
`static int` `DEFAULT_MAX_NGRAM_SIZE`
`static int` `DEFAULT_MIN_NGRAM_SIZE`

### Fields inherited from class org.apache.lucene.analysis.Tokenizer

`input`

### Constructor Summary

Constructors
Constructor and Description
`NGramTokenizer(AttributeSource.AttributeFactory factory, Reader input, int minGram, int maxGram)` Creates NGramTokenizer with given min and max n-grams.
`NGramTokenizer(AttributeSource source, Reader input, int minGram, int maxGram)` Creates NGramTokenizer with given min and max n-grams.
`NGramTokenizer(Reader input)` Creates NGramTokenizer with default min and max n-grams.
`NGramTokenizer(Reader input, int minGram, int maxGram)` Creates NGramTokenizer with given min and max n-grams.

### Method Summary

Methods
`void` `end()`
`boolean` `incrementToken()` Returns the next token in the stream, or null at EOS.
`void` `reset()`

### Methods inherited from class org.apache.lucene.analysis.Tokenizer

`close, correctOffset, setReader`

### Methods inherited from class org.apache.lucene.util.AttributeSource

`addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, restoreState`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### DEFAULT_MIN_NGRAM_SIZE

    public static final int DEFAULT_MIN_NGRAM_SIZE

See Also:
  Constant Field Values

#### DEFAULT_MAX_NGRAM_SIZE

    public static final int DEFAULT_MAX_NGRAM_SIZE

See Also:
  Constant Field Values

### Constructor Detail

#### NGramTokenizer

    public NGramTokenizer(Reader input,
                  int minGram,
                  int maxGram)

Creates NGramTokenizer with given min and max n-grams.

Parameters:
  `input` - `Reader` holding the input to be tokenized
  `minGram` - the smallest n-gram to generate
  `maxGram` - the largest n-gram to generate

#### NGramTokenizer

    public NGramTokenizer(AttributeSource source,
                  Reader input,
                  int minGram,
                  int maxGram)

Creates NGramTokenizer with given min and max n-grams.

Parameters:
  `source` - `AttributeSource` to use
  `input` - `Reader` holding the input to be tokenized
  `minGram` - the smallest n-gram to generate
  `maxGram` - the largest n-gram to generate

#### NGramTokenizer

    public NGramTokenizer(AttributeSource.AttributeFactory factory,
                  Reader input,
                  int minGram,
                  int maxGram)

Creates NGramTokenizer with given min and max n-grams.

Parameters:
  `factory` - `AttributeSource.AttributeFactory` to use
  `input` - `Reader` holding the input to be tokenized
  `minGram` - the smallest n-gram to generate
  `maxGram` - the largest n-gram to generate

#### NGramTokenizer

    public NGramTokenizer(Reader input)

Creates NGramTokenizer with default min and max n-grams.

Parameters:
  `input` - `Reader` holding the input to be tokenized

### Method Detail

#### incrementToken

    public boolean incrementToken()
                           throws IOException

Returns the next token in the stream, or null at EOS.

Specified by:
  `incrementToken` in class `TokenStream`
Throws:
  `IOException`

#### end

    public void end()

Overrides:
  `end` in class `TokenStream`

#### reset

    public void reset()
               throws IOException

Overrides:
  `reset` in class `TokenStream`
Throws:
  `IOException`